/**********************************************************
* FILE STACK.H version 1.0 05/10/94
*
* DESCRIPTION:
*  contains all stack's defines and prototypes.
*
* NOTES:
*
* Copyright 1993 by EZ Software 
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose and without fee is hereby granted, provided 
* that the above copyright notice appear in all copies and that both that 
* copyright notice and this permission notice appear in supporting 
* documentation, and that the name of EZ Software 
* not be used in advertising or publicity pertaining to distribution of the 
* software without specific written prior permission. 
* EZ Software makes no representations about the 
* suitability of this software for any purpose.  It is provided "as is"
* without express or implied warranty.
*
* EZ Software DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
* SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, 
* IN NO EVENT SHALL EZ Software BE LIABLE FOR ANY SPECIAL,
* INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES RESULTING FROM LOSS OF USE,
* DATA OR PROFITS, WHETHER IN AN ACTION CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
* ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
* SOFTWARE.
*
*
*  Original Author: Laurent Chavey, EZ Software 
*           (chavey@cis.udel.edu)
*            june, 1993
*
**********************************************************/
#ifndef STACK_H
#define STACK_H

#include <malloc.h>
#include <stdio.h>
#include <memory.h>

/*************** PARAM **********************************/

/************** ERROR **********************************/
#define STKGENERROR  -1
#define STKNOERROR   0
#define STKINVPARA   1
#define STKEMPTY     2

/************* STRUCTURE *******************************/
typedef struct {
   struct stackelement *lpNext;
   void  *lpData;
} stackelement;

typedef struct {
  stackelement *lpTop;
  int          nDataSize;
} stack;

/*********************************************************
   MACROS
*********************************************************/

#ifdef STACK 

   #define X_ 

   #undef STACK 
#else
   #define X_ extern
#endif

   /*********************** PRIMITIVES ******************/
   X_ stack      *stknew         (int);
   X_ int         stkfree        (stack *);
   X_ int         stkpush        (stack *, void *);
   X_ int         stkpop         (stack *, void *);
   X_ int         stknumber      (stack *);

   /*********************** DEBUG **********************/
   X_ int         stkdum         (stack *);

   #undef X_
#endif


